﻿using Newtonsoft.Json.Linq;
using System;
using System.Diagnostics;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;

namespace FeatureGuideCharp
{
    class _09_23_time_based_expiry_REST
    {
        public  void Execute()
        {
            var apiKey = "your_api_key";
            var apiUrl = "https://sandbox.esignlive.com/api";

            StringBuilder sb = new StringBuilder(200);
            sb.AppendLine("{                                                                                                 ");
            sb.AppendLine("  \"status\": \"DRAFT\",                                                                          ");
            sb.AppendLine("              \"description\": \"A test transaction for Time-based Expiry feature.\",             ");
            sb.AppendLine("              \"language\": \"en\",                                                               ");
            sb.AppendLine("              \"timezoneId\": \"GMT\",                                                            ");
            sb.AppendLine("              \"settings\": {                                                                     ");
            sb.AppendLine("                \"ceremony\": {                                                                   ");
            sb.AppendLine("                  \"defaultTimeBasedExpiry\": true,                                               ");
            sb.AppendLine("                  \"remainingDays\": 15                                                           ");
            sb.AppendLine("                }                                                                                 ");
            sb.AppendLine("        },                                                                                        ");
            sb.AppendLine("  \"type\": \"PACKAGE\",                                                                          ");
            sb.AppendLine("  \"name\": \"Test Time based Expiry\"                                                            ");
            sb.AppendLine("}                                                                                                 ");


            string jsonString = sb.ToString();
            Debug.WriteLine(jsonString);
            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");
            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var result = myClient.PostAsync(new Uri(apiUrl) + "/packages/", jsonContent).Result;
            JObject returnJSON = JObject.Parse(result.Content.ReadAsStringAsync().Result);
            string pkgId = returnJSON["id"].ToString();

            Debug.WriteLine(pkgId);

            //check expiry date
            var result2 = myClient.GetAsync(new Uri(apiUrl) + "/packages/" + pkgId).Result;
            JObject returnJSON2 = JObject.Parse(result2.Content.ReadAsStringAsync().Result);
            string expiryDate = returnJSON2["due"].ToString();
            string createDate = returnJSON2["created"].ToString();

            Debug.WriteLine("expired at (GMT): " + expiryDate);
            Debug.WriteLine("created at (GMT): " + createDate);


        }
    }
}
